# openmamba cross platform gcc specfile
#%define git_commit 9a167ee2f8b9a0859fbab6cfdc276cf1f272effe
#%define git_commit_ver 13.1.1

%define target_cpu %(echo %{_target_platform} | cut -d- -f1)
%if "%{?_target_platform}" != "%{_host}"
#   % define target_platform %{cross_target_cpu}-openmamba-linux-gnu
#   % define target_cpu %{cross_target_cpu}
   %define _as %{_target_platform}-as
   %define _ld %{_target_platform}-ld
   %if "%{target_cpu}" == "x86_64"
      %define _lib lib64
   %endif
%else
#   % define target_platform %{_target_platform}
   %define target_cpu %{_target_cpu}
   %define _as as
   %define _ld ld
%endif

%define gcc_branch            %(echo %{version} | cut -d. -f 1-2)
#% define gcc_extraver          -20050810

# use stage1 == 1 to have a gcc build not depending on
# glibc library; this is usually the first needed step in
# order to add support for a new (cross)target platform
%if "%{?stage1}" == "1"
   %define bootstrap_append    -stage1
   %define disable_cpp 1
   %define disable_doc 1
   %define disable_go 1
%endif

#% if "%{?stage2}" == "1"
#   % define bootstrap_append    -stage2
#% endif

%define libstdcxx_name        libstdc++6

%define MAJver %(echo %version | cut -d. -f 1)
%define majver %(echo %version | cut -d. -f 1-2)

Name:          gcc
Version:       14.1.0
Release:       1mamba
Summary:       GNU Compiler Collection (C, C++, Fortran, Go, Ada)
Group:         Applications/Development
Vendor:        openmamba
Distribution:  openmamba
Packager:      Silvan Calarco <silvan.calarco@mambasoft.it>
URL:           https://gcc.gnu.org/
Source:        https://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-%{version}.tar.xz
Patch0:        gcc-10.1.0-arm-provide-futex-atomic-functions.patch
Patch1:        gcc-13.1.1-libgomp-workaround-null-environ.patch
License:       GPL
## AUTOBUILDREQ-BEGIN
## AUTOBUILDREQ-END
%if "%{?cross_target_cpu}" == ""
BuildRequires: binutils
%else
BuildRequires: cross-%{_target_platform}-binutils
%if "%{?stage1}" == "1"
BuildRequires: cross-%{_target_platform}-glibc-stage1
%endif
#%if "%{?stage2}" == "1"
#BuildRequires: cross-%{_target_platform}-glibc-stage2
#%endif
%if "%{?stage1}" != "1"
%if "%{?stage2}" != "1"
%if "%{target_cpu}" != "avr"
BuildRequires: cross-%{_target_platform}-glibc
%endif
%endif
%endif
%endif
BuildRequires: diffutils
BuildRequires: flex
BuildRequires: gettext
BuildRequires: bison
BuildRequires: libmpc-devel
BuildRequires: libmpfr-devel >= 2.1.2
BuildRequires: libz-devel
BuildRequires: texinfo >= 4.6
%if "%{_target_platform}" == "%{_build}"
BuildRequires: glibc-devel >= 2.5
#%ifarch x86_64
#BuildRequires: glibc-multilib-devel
#%endif
#% if "%{?stage2}" != "1"
BuildRequires: gcc-d
BuildRequires: libalsa-devel >= 1.0.11
BuildRequires: libcairo-devel >= 1.4.10
BuildRequires: libgtk2-devel >= 2.8.17
BuildRequires: libisl-devel >= 0.14
BuildRequires: libxcb-util-devel >= 0.2
BuildRequires: libxcrypt-devel
BuildRequires: tetex >= 3.0
#% endif
#% else
#BuildRequires: cross-%{target_cpu}-glibc%{?glibc_require_append} >= 2.5
%endif
#BuildConflicts: libldc-devel
Requires(post):%{__install_info}
Requires:      %{name}-cpp = %{version}-%{release}
Requires:      libgcc >= %{version}-%{release}
Requires:      binutils >= 2.16.1

%description
A compiler aimed at integrating all the optimizations and features necessary for a high-performance and stable development environment.
This package is required for all other GCC compilers, namely C++, Fortran, Objective C and Java.

%package -n gcc-multilib
Summary:       gcc multilib package for building 32 bit applications on x86_64 architecture
Group:         Applications/Development
Provides:      libgcc_s.so.1
Provides:      libgcc_s.so.1(GCC_3.0)
Provides:      libgcc_s.so.1(GCC_3.3)
Provides:      libgcc_s.so.1(GCC_3.3.1)
Provides:      libgcc_s.so.1(GCC_3.4)
Provides:      libgcc_s.so.1(GCC_3.4.2)
Provides:      libgcc_s.so.1(GCC_4.0.0)
Provides:      libgcc_s.so.1(GCC_4.2.0)
Provides:      libgcc_s.so.1(GCC_4.3.0)
Provides:      libgcc_s.so.1(GCC_4.4.0)
Provides:      libgcc_s.so.1(GCC_4.5.0)
Provides:      libgcc_s.so.1(GCC_4.7.0)
Provides:      libgcc_s.so.1(GCC_4.8.0)
Provides:      libgcc_s.so.1(GCC_7.0.0)
Provides:      libgcc_s.so.1(GLIBC_2.0)

%description -n gcc-multilib
gcc multilib package for building 32 bit applications on x86_64 architecture.

#
# GCC Library
#
%package -n libgcc
Summary:       GNU C Library
Group:         System/Libraries
%ifarch x86_64
Provides:      libgcc_s.so.1()(64bit)
Provides:      libgcc_s.so.1(GCC_3.0)(64bit)
Provides:      libgcc_s.so.1(GCC_3.3)(64bit)
Provides:      libgcc_s.so.1(GCC_3.3.1)(64bit)
Provides:      libgcc_s.so.1(GCC_3.4)(64bit)
Provides:      libgcc_s.so.1(GCC_3.4.2)(64bit)
Provides:      libgcc_s.so.1(GCC_3.4.4)(64bit)
Provides:      libgcc_s.so.1(GCC_4.0.0)(64bit)
Provides:      libgcc_s.so.1(GCC_4.2.0)(64bit)
Provides:      libgcc_s.so.1(GCC_4.3.0)(64bit)
Provides:      libgcc_s.so.1(GCC_4.7.0)(64bit)
Provides:      libgcc_s.so.1(GCC_4.8.0)(64bit)
Provides:      libgcc_s.so.1(GCC_7.0.0)(64bit)
%endif
%ifarch %{ix86}
Provides:      libgcc_s.so.1
Provides:      libgcc_s.so.1(GCC_3.0)
Provides:      libgcc_s.so.1(GCC_3.3)
Provides:      libgcc_s.so.1(GCC_3.3.1)
Provides:      libgcc_s.so.1(GCC_3.4)
Provides:      libgcc_s.so.1(GCC_3.4.2)
Provides:      libgcc_s.so.1(GCC_4.0.0)
Provides:      libgcc_s.so.1(GCC_4.2.0)
Provides:      libgcc_s.so.1(GCC_4.3.0)
Provides:      libgcc_s.so.1(GCC_4.4.0)
Provides:      libgcc_s.so.1(GCC_4.5.0)
Provides:      libgcc_s.so.1(GCC_4.7.0)
Provides:      libgcc_s.so.1(GCC_4.8.0)
Provides:      libgcc_s.so.1(GCC_7.0.0)
Provides:      libgcc_s.so.1(GLIBC_2.0)
%endif
%ifarch arm
Provides:      libgcc_s.so.1
Provides:      libgcc_s.so.1(GCC_3.0)
Provides:      libgcc_s.so.1(GCC_3.3)
Provides:      libgcc_s.so.1(GCC_3.3.1)
Provides:      libgcc_s.so.1(GCC_3.3.4)
Provides:      libgcc_s.so.1(GCC_3.4)
Provides:      libgcc_s.so.1(GCC_3.4.2)
Provides:      libgcc_s.so.1(GCC_3.5)
Provides:      libgcc_s.so.1(GCC_4.0.0)
Provides:      libgcc_s.so.1(GCC_4.2.0)
Provides:      libgcc_s.so.1(GCC_4.3.0)
Provides:      libgcc_s.so.1(GCC_4.7.0)
Provides:      libgcc_s.so.1(GCC_7.0.0)
Provides:      libgcc_s.so.1(GLIBC_2.0)
%endif

%description -n libgcc
The libgcc package contains GCC shared libraries for gcc %{gcc_branch}.

#
# Preprocessor
#
%package cpp
Summary:       The C Preprocessor
Group:         Development/Libraries
#Requires:      %{name} = %{version}-%{release}

%description cpp
The C preprocessor is a `macro processor' which is used automatically by the C compiler to transform your program before actual compilation.
It is called a macro processor because it allows you to define `macros,' which are abbreviations for longer constructs.

The C preprocessor provides four separate facilities that you can use as you see fit:
 * Inclusion of header files. These are files of declarations that can be substituted into your program.
 * Macro expansion. You can define 'macros,' which are abbreviations for arbitrary fragments of C code, and then the C preprocessor will replace the macros with their definitions throughout the program.
 * Conditional compilation. Using special preprocessing directives, you can include or exclude parts of the program according to various conditions.
 * Line control. If you use a program to combine or rearrange source files into an intermediate file which is then compiled, you can use line control to inform the compiler about where each source line originated.

You should install this package if you are a programmer who is searching for such a macro processor.

#
# C++ Compiler
#
%package c++
Summary:       C++ support for gcc
Group:         Applications/Development
Requires:      %{name} = %{version}-%{release}
Requires:      %{libstdcxx_name} = %{version}
Requires:      %{libstdcxx_name}-devel = %{version}

%description c++
This package adds C++ support to the GNU C compiler. It includes support for most of the current C++ specification, including templates and exception handling. It does include the static standard C++ library and C++ header files. 
The library for dynamically linking programs is available separately.

#
# C++ Library
#
%package -n %{libstdcxx_name}
Summary:       GNU C++ library
Group:         System/Libraries
Provides:      libstdc++
%ifarch aarch64
# Fake provide
Provides:      libquadmath
%endif

%description -n %{libstdcxx_name}
This package contains the GCC Standard C++ Library v3, an ongoing project to implement the ISO/IEC 14882:1998 Standard C++ library.

%package -n %{libstdcxx_name}-devel
Summary:       GNU C++ library development files
Group:         Development/Libraries
Requires:      %{libstdcxx_name} = %{version}-%{release}
%ifarch aarch64
# Fake provide
Provides:      libquadmath-devel
%endif

%description -n %{libstdcxx_name}-devel
This is the GNU implementation of the standard C++ libraries.
This package includes the headers files and libraries needed for C++ development.

%package -n %{libstdcxx_name}-debug
Summary:       GNU C++ library debug files
Group:         Development/Libraries
Requires:      %{libstdcxx_name} = %{version}-%{release}

%description -n %{libstdcxx_name}-debug
This is the GNU implementation of the standard C++ libraries.
This package includes the files used by gdb for debugging.

%package -n libcc1
Summary:       GNU cc1 plugin for GDB
Group:         System/Libraries

%description -n libcc1
GCC cc1 plugin for GDB.

%package -n libcc1-devel
Summary:       GNU cc1 plugin for GDB development files
Group:         Development/Libraries
Requires:      libcc1 = %{version}-%{release}

%description -n libcc1-devel
GCC cc1 plugin for GDB development files.

#
# D compiler
#
%package d
Summary:       The GNU compiler for the D programming language
Group:         System/Libraries
Requires:      libgdruntime = %{version}-%{release}

%description d
The GNU compiler for the Go programming language.

%package -n libgdruntime
Summary:        GCC D language runtime library
Group:          System/Libraries

%description -n libgdruntime
This package contains the GCC D language runtime library.

#
# Fortran 95 Compiler
#
%package fortran
Summary:       Fortran 95 support for gcc
Group:         Applications/Development
Requires:      libgfortran = %{version}-%{release}
Requires:      %{name} = %{version}-%{release}
Obsoletes:     gcc-g77 < 10.3.0
Obsoletes:     gcc-gfortran < 10.3.0

%description fortran
This package adds support for compiling Fortran 95 programs with the GNU compiler.

#
# Go compiler
#
%package go
Summary:       The GNU compiler for the Go programming language
Group:         System/Libraries
Requires:      libgo = %{version}-%{release}
Requires:      libgo-devel = %{version}-%{release}

%description go
The GNU compiler for the Go programming language.

%package -n libgo
Summary:       Library for the Go programmi language
Group:         System/Libraries

%description -n libgo
Library for the Go programmi language.

%package -n libgo-devel
Summary:        Development headers and static library for libgo
Group:          Development/Libraries
Requires:       libgo = %{version}-%{release}

%description -n libgo-devel
Development files for the library for the Go programmi language.

#
# Fortran 95 Libraries
#
%package -n libgfortran
Summary:       Fortran 95 runtime libraries
Group:         System/Libraries

%description -n libgfortran
This package contains Fortran 95 shared library which is needed to run Fortran 95 dynamically linked programs.

%package -n libiberty-devel
Summary:        Development files for libiberty
Group:          Development/Libraries

%description -n libiberty-devel
This package contains the libiberty static library and includes.

%package -n libitm
Summary:        Transactional Memory library
Group:          System/Libraries

%description -n libitm
This package contains the GNU Transactional Memory library.

%package -n libitm-devel
Summary:        Development files for libitm
Group:          Development/Libraries
Requires:       libobjc = %{version}-%{release}

%description -n libitm-devel
This package contains libitm static library and includes.

%package -n libgomp
Summary:       GNU OpenMP library
Group:         System/Libraries

%description -n libgomp
An implementation of OpenMP for the C, C++, and Fortran 95 compilers in the GNU Compiler Collection.

%package -n libgomp-devel
Summary:        Development headers and static library for libgomp
Group:          Development/Libraries
Requires:       libgomp = %{version}-%{release}

%description -n libgomp-devel
An implementation of OpenMP for the C, C++, and Fortran 95 compilers in the GNU Compiler Collection.
This package contains development headers and static library for libgomp

%package -n libobjc
Summary:        Objective-C runtime library
Group:          System/Libraries

%description -n libobjc
This package contains Objective-C shared library which is needed to run Objective-C dynamically linked programs.

%package -n libobjc-devel
Summary:        Objective-C static library
Group:          Development/Libraries
Requires:       libobjc = %{version}-%{release}

%description -n libobjc-devel
This package contains Objective-C static library and includes which are needed to build Objective-C statically linked programs.

#
# libmpx packages
#
%package -n libmpx
Summary:        GCC MPX library
Group:          System/Libraries

%description -n libmpx
This package contains the GCC MPX library.

%package -n libmpx-devel
Summary:        libmpx development libraries and headers
Group:          Development/Libraries
Requires:       libmpx = %{version}-%{release}

%description -n libmpx-devel
This package contains static libraries and headers to be used for development.

#
# libssp packages
#
%package -n libssp
Summary:       GCC extension library for protecting applications from stack-smashing attacks
Group:         System/Libraries

%description -n libssp
GCC extension library for protecting applications from stack-smashing attacks.

%package -n libssp-devel
Summary:        GCC extension library for protecting applications from stack-smashing attacks
Group:          Development/Libraries
Requires:       libssp = %{version}-%{release}

%description -n libssp-devel
GCC extension library for protecting applications from stack-smashing attacks.
This package contains static libraries and headers to be used for development.

#
# libquadmath packages
#
%package -n libquadmath
Summary:       GCC Quad-Precision (__float128) Math Library Application Programming Interface (API)
Group:         System/Libraries

%description -n libquadmath
GCC Quad-Precision (__float128) Math Library Application Programming Interface (API).

%package -n libquadmath-devel
Summary:        GCC Quad-Precision (__float128) Math Library Application Programming Interface (API)
Group:          Development/Libraries
Requires:       libquadmath = %{version}-%{release}

%description -n libquadmath-devel
GCC Quad-Precision (__float128) Math Library Application Programming Interface (API).

This package contains static libraries and headers to be used for development.

%package -n libasan
Summary:        GCC Address Sanitizer library
Group:          System/Libraries

%description -n libasan
This package contains the GCC Address Sanitizer library.

%package -n libasan-devel
Summary:        libasan development libraries and headers
Group:          Development/Libraries
Requires:       libasan = %{version}-%{release}

%description -n libasan-devel
This package contains static libraries and headers to be used for development.

%package -n libhwasan
Summary:        GCC HW address sanitizer runtime library
Group:          System/Libraries

%description -n libhwasan
This package contains the GCC HW addess sanitizer runtime library.

%package -n libhwasan-devel
Summary:        libhwasan development libraries and headers
Group:          Development/Libraries
Requires:       libhwasan = %{version}-%{release}

%description -n libhwasan-devel
This package contains static libraries and headers to be used for development.

%package -n liblsan
Summary:        GCC Leak Sanitizer runtime library
Group:          System/Libraries

%description -n liblsan
This package contains the GCC Leak Sanitizer runtime library.

%package -n liblsan-devel
Summary:        liblsan development libraries and headers
Group:          Development/Libraries
Requires:       liblsan = %{version}-%{release}

%description -n liblsan-devel
This package contains static libraries and headers to be used for development.

%package -n libatomic
Summary:        GCC Atomic library
Group:          System/Libraries

%description -n libatomic
This package contains the GCC Atomic library.

%package -n libatomic-devel
Summary:        libatomic development libraries and headers
Group:          Development/Libraries
Requires:       libatomic = %{version}-%{release}

%description -n libatomic-devel
This package contains static libraries and headers to be used for development.

%package -n libcilkrts
Summary:        GCC Cilk runtime library
Group:          System/Libraries

%description -n libcilkrts
This package contains the GCC Cilk runtime library.

%package -n libcilkrts-devel
Summary:        libubsan development libraries and headers
Group:          Development/Libraries
Requires:       libcilkrts = %{version}-%{release}

%description -n libcilkrts-devel
This package contains static libraries and headers to be used for development.

%package -n libubsan
Summary:        GCC Undefined Behavior Sanitizer library
Group:          System/Libraries

%description -n libubsan
This package contains the GCC Undefined Behavior Sanitizer library.

%package -n libubsan-devel
Summary:        libubsan development libraries and headers
Group:          Development/Libraries
Requires:       libubsan = %{version}-%{release}

%description -n libubsan-devel
This package contains static libraries and headers to be used for development.

%package -n libvtv
Summary:        GCC vtable verification library
Group:          System/Libraries

%description -n libvtv
This package contains the GCC vtable verification library.

%package -n libvtv-devel
Summary:        libubsan development libraries and headers
Group:          Development/Libraries
Requires:       libvtv = %{version}-%{release}

%description -n libvtv-devel
This package contains static libraries and headers to be used for development.

#
# Documentation
#
%package doc
Group:         Documentation
Summary:       GCC documentation

%description doc
GCC is a compiler suite aimed at integrating all the optimizations and features necessary for a high-performance and stable development environment. 
This package contains the compiler documentation in INFO pages.

%package -n cross-%{_target_platform}-%{name}%{?bootstrap_append}
Summary:       Cross Platform gcc for %{_target_platform}
Group:         Development/Tools
Requires:      cross-%{_target_platform}-binutils
%if "%{?stage1}" != "1"
Obsoletes:     cross-%{_target_platform}-%{name}-stage1 <= %{version}
%endif
AutoReqProv:   no

%description -n cross-%{_target_platform}-%{name}%{?bootstrap_append}
Cross Platform gcc for %{_target_platform}.

%if "%{_target_platform}" == "%{_host}"
%debug_package
%endif

# Don't clean build at the end
%global __spec_rmbuild_cmd /bin/true

%prep
#%if "%{git_commit_ver}" != "%{version}"
#echo "Needed to update git commit for gcc %{version}"
#exit 1
#%endif

%setup -q -n gcc-%{version}%{?gcc_extraver}
#-D -T
#:<< ___EOF

%if "%{_target_platform}" != "%{_host}"
%define _build_id_links none
%endif

%patch 0 -p1

%ifarch arm
%patch 1 -p1
## workaround for gcc-go
#cp libgo/go/internal/syscall/unix/{getrandom_linux_arm.go,dummy.go}
cat >> libgo/go/internal/syscall/unix/dummy.go << __EOF

const (
        getrandomTrap     uintptr = 384
        copyFileRangeTrap uintptr = 391
)
__EOF
%endif

# Do not run fixincludes
sed -i 's@\./fixinc\.sh@-c true@' gcc/Makefile.in

%build
#:<< ____EOF
rm -rf ../%{name}-build-%{_target_platform}
#____EOF
mkdir -p ../%{name}-build-%{_target_platform}

cd ../%{name}-build-%{_target_platform}

slibdir=%{_libdir}

# BUILD_LANGUAGES is only used in final (not staged) build
BUILD_LANGUAGES=c,objc,lto,d

# TODO: ada: configure: error: GNAT is required to build ada

%if "%{disable_cpp}" != "1"
# Fortran won't build cross platform (?)
BUILD_LANGUAGES="${BUILD_LANGUAGES},c++,obj-c++"
%endif
%if "%{disable_fortran}" != "1"
# Fortran won't build cross platform (?)
BUILD_LANGUAGES="${BUILD_LANGUAGES},fortran"
%endif
%if "%{disable_go}" != "1"
BUILD_LANGUAGES="${BUILD_LANGUAGES},go"
%endif

case %{_target_platform} in
   i386-*|i486-*|i586-*|i686-*|athlon-*)
      ADDITIONAL_OPTS="--with-arch=pentium4"
      ;;
   ppc-* | powerpc-*)
      ADDITIONAL_OPTS=""
      ;;
   arm-*)
 	  abi=%{_target_platform}
 	  abi=`echo ${abi/*-}`
	  if [ "$abi" = "gnueabihf" ]; then
         ADDITIONAL_OPTS="--with-float=hard"
	  else
         ADDITIONAL_OPTS=""
	  fi
      #"--enable-multilib"
      ;;
   avr*)
      ADDITIONAL_OPTS="--with-dwarf2"
      BUILD_LANGUAGES="c,c++"
      ;;
   x86_64-*)
       %if "%{_target_platform}" != "%{_host}"
          ADDITIONAL_OPTS="--with-slibdir=/usr/%{_target_platform}/lib64 --disable-multilib"
       %else
          ADDITIONAL_OPTS="--with-slibdir=$slibdir --enable-multilib"
       %endif
       ;;
   aarch64-*)
       %if "%{_target_platform}" != "%{_host}"
          ADDITIONAL_OPTS="--with-slibdir=/usr/%{_target_platform}/lib64"
       %else
          ADDITIONAL_OPTS="--with-slibdir=$slibdir"
       %endif
       ;;
   *)
      echo "Error: target not supported."
      exit 1
      ;;
esac

%if "%{?stage1}" == "1"

../gcc-%{version}%{?gcc_extraver}/configure \
   --host=%{_host} \
   --build=%{_build} \
   --target=%{_target_platform} \
   --prefix=%{_prefix} \
   --libdir=%{_libdir} \
   --infodir=%{_infodir} \
   --mandir=%{_mandir} \
   --disable-nls \
   --disable-shared \
   --disable-threads \
   --enable-languages=c \
   --with-newlib \
   --without-headers \
   --disable-libssp \
   --disable-libgomp \
   --disable-libquadmath \
   --disable-libatomic \
%if "%{_target_platform}" != "%{_host}"
   --with-local-prefix=/usr/%{_target_platform} \
%endif
   $ADDITIONAL_OPTS

make %{?_smp_mflags}
# all-gcc

%else

CROSS_SYSTEM_HEADER_DIR=/usr/%{_target_platform}/include \
../gcc-%{version}%{?gcc_extraver}/configure \
   --prefix=%{_prefix} \
   --libdir=%{_libdir} \
   --infodir=%{_infodir} \
   --mandir=%{_mandir} \
   --with-bugurl="https://bugs.openmamba.org/" \
   --host=%{_host} \
   --build=%{_build} \
   --target=%{_target_platform} \
   --enable-shared \
   --enable-lto \
   --enable-gnu-unique-object \
   --enable-linker-build-id \
   --with-linker-hash-style=gnu \
   --enable-gnu-indirect-function \
   --enable-plugin \
   --disable-libunwind-exceptions \
   --enable-clocale=gnu \
   --disable-libstdcxx-pch \
   --disable-werror \
   --enable-checking=release \
   --enable-default-pie \
   --enable-default-ssp \
   --enable-cet=auto \
   --enable-languages=$BUILD_LANGUAGES \
%if "%{target_cpu}" != "avr"
   --enable-threads=posix \
   --enable-__cxa_atexit \
   --enable-clocale=gnu \
   --x-includes=%{_includedir} \
   --x-libraries=%{_libdir} \
   --with-system-zlib \
   --with-isl \
%if "%{_target_platform}" != "%{_host}"
   --enable-symvers=gnu \
   --disable-libsanitizer \
   --with-local-prefix=/usr/%{_target_platform} \
%else
   --enable-install-libiberty \
   --with-slibdir=$slibdir \
%endif
%endif
   $ADDITIONAL_OPTS
   
#   --with-headers=yes \
#   --with-headers=/usr/%{_target_platform}/include  \

%if "%{_target_platform}" != "%{_build}"
   # FTBFS Workaround: see
   # http://www.linuxfromscratch.org/lfs/view/development/chapter05/gcc-pass2.html
   mkdir -p gcc/include-fixed
   cat ../gcc-%{version}/gcc/{limitx.h,glimits.h,limity.h} > gcc/include-fixed/limits.h
   make %{?_smp_mflags} CFLAGS='' LIBCFLAGS='-g -O2' \
      LIBCXXFLAGS='-g -O2 -fno-implicit-templates' all \
%ifarch x86_64
	  CXXCPP=%{_libdir}/cpp
%endif

%else
   make %{?_smp_mflags} CFLAGS="%{optflags}" CXXFLAGS="%{optflags}"
#   CFLAGS='-O -I/usr/include/freetype2' LIBCFLAGS='-g -O2' \
#      LIBCXXFLAGS='-g -O2 -fno-implicit-templates' bootstrap
%endif

%if "%{target_cpu}" != "avr"
%if "%{disable_doc}" != "1"
# Make generated doxygen pages.
make -C %{_target_platform}/libstdc++-v3 doc-html-doxygen
make -C %{_target_platform}/libstdc++-v3 doc-man-doxygen
cd ../..
#   make pdf || make pdf
%endif
%endif

%endif

%install
[ "%{buildroot}" != "/" ] && rm -rf "%{buildroot}"

cd ../%{name}-build-%{_target_platform}
make DESTDIR=%{buildroot} install

%if "%{_target_platform}" == "%{_host}"
install -m644 libiberty/pic/libiberty.a %{buildroot}%{_libdir}/libiberty.a

# make target platform binaries symlinks to avoid binary duplicates
for p in gcc-%{version} gcc gcc-ar gcc-nm gcc-ranlib c++ g++ gfortran; do
   rm -f %{buildroot}%{_bindir}/%{_target_platform}-$p
done

ln -s gcc %{buildroot}%{_bindir}/%{_target_platform}-gcc-%{version}

for p in gcc gcc-ar gcc-nm gcc-ranlib cc gcov c++ g++ gfortran; do
   ln -s $p %{buildroot}%{_bindir}/%{_target_platform}-$p
done

# Allow go command to come from go package
mv %{buildroot}%{_bindir}/go %{buildroot}%{_bindir}/gcc-go

install -d -m755 %{buildroot}%{_libdir}/bfd-plugins
ln -sf ../../libexec/gcc/%{_target_platform}/%{version}/liblto_plugin.so %{buildroot}%{_libdir}/bfd-plugins/

# create symlinks
#   mkdir -p %{buildroot}/%{_lib}
#   ln -s ../usr/bin/cpp %{buildroot}/%{_lib}/cpp
ln -s ../bin/cpp %{buildroot}%{_libdir}
ln -s gcc %{buildroot}/usr/bin/cc

#
# Documentation
#
#
# PDF gfortran documentation
#
#(cd ../gcc-%{version}%{?gcc_extraver}/gcc/fortran;
#   texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include -I ../../../gcc-build/gcc gfortran.texi)

#
# copy PDF gcc documentation to builddir for use with %doc
#
#%if "%{disable_doc}" != "1"
#cp gcc/doc/*.pdf %{_builddir}/gcc-%{version}%{?gcc_extraver}/gcc/doc/
#%endif

# FIXME: since 4.5.0 this file causes an annoying warning with ldconfig if installed in /usr/lib
mkdir -p %{buildroot}%{_datadir}/gdb/auto-load/%{_libdir}
mv %{buildroot}%{_libdir}/libstdc++.so.*-gdb.py %{buildroot}%{_datadir}/gdb/auto-load/%{_libdir}/
%ifarch x86_64
# fix for 32bit multilib build
mkdir -p %{buildroot}%{_datadir}/gdb/auto-load/%{_prefix}/lib32
mv %{buildroot}%{_prefix}/lib32/libstdc++.so.*-gdb.py %{buildroot}%{_datadir}/gdb/auto-load/%{_prefix}/lib32/
# set /usr/lib32 for ldconfig
install -d -m0755 %{buildroot}%{_sysconfdir}/ld.so.conf.d
cat > %{buildroot}%{_sysconfdir}/ld.so.conf.d/lib32-gcc.conf << EOF
/usr/lib32
EOF
%endif

(cd ../gcc-%{version}%{?gcc_extraver}
%find_lang gcc
%find_lang cpplib
%find_lang libstdc++
)

#(cd ../gcc-%{version}%{?gcc_extraver}/gcc/doc; 
#   for file in gcc.texi cpp.texi cppinternals.texi; do
#   texi2dvi -p -t @afourpaper -t @finalout -I ./include -I ../../../gcc-build/gcc $file
#done)

# fix permissions
chmod 755 %{buildroot}/%{_libdir}/libgcc_s.so.1
#cp gcc/doc/*.pdf ../gcc-%{version}%{?gcc_extraver}/gcc/doc/

%else
# target_platform != host
   rm -rf %{buildroot}%{_infodir}/*
   rm -rf %{buildroot}%{_mandir}/man7/{fsf-funding.*,gfdl.*,gpl.*}
   rm -rf %{buildroot}%{_datadir}/locale/*
   rm -rf %{buildroot}%{_datadir}/gcc-%{version}/python/libstdcxx/*
   # FIXME: since 5.2.0
   rm -rf %{buildroot}%{_libdir}/libcc1.*
%endif
# remove ffi provided by external package
rm -f %{buildroot}%{_libdir}/libffi*
rm -f %{buildroot}%{_libdir}/nof/libffi*
rm -f %{buildroot}%{_mandir}/man3/ffi*.3*
rm -f %{buildroot}%{_infodir}/libffi.info*

## don't strip libraries for avr
#%if "%{target_cpu}" == "avr"
#find %{buildroot}%{_libdir}/gcc -name lib*.a -exec chmod -w {} \;
#%endif

rm -f %{buildroot}%{_infodir}/dir

%clean
[ "%{buildroot}" != "/" ] && rm -rf "%{buildroot}"

%post -n libgcc -p /sbin/ldconfig
%postun -n libgcc -p /sbin/ldconfig

%post -n %{libstdcxx_name} -p /sbin/ldconfig
%postun -n %{libstdcxx_name} -p /sbin/ldconfig

%post -n libgdruntime -p /sbin/ldconfig
%postun -n libgdruntime -p /sbin/ldconfig

%post -n libgfortran -p /sbin/ldconfig
%postun -n libgfortran -p /sbin/ldconfig

%post -n libquadmath -p /sbin/ldconfig
%postun -n libquadmath -p /sbin/ldconfig

%post -n libatomic -p /sbin/ldconfig
%postun -n libatomic -p /sbin/ldconfig

%post -n libasan -p /sbin/ldconfig
%postun -n libasan -p /sbin/ldconfig

%post -n liblsan -p /sbin/ldconfig
%postun -n liblsan -p /sbin/ldconfig

%post doc
%install_info cppinternals.info
%install_info gcc.info
%install_info gccinstall.info
%install_info gccint.info
%if "%{disable_fortran}" != "1"
%install_info gfortran.info
%endif
:

%preun doc
%uninstall_info cppinternals.info
%uninstall_info gcc.info
%uninstall_info gccinstall.info
%uninstall_info gccint.info
%uninstall_info gfortran.info
:


%if "%{_target_platform}" == "%{_host}"

#
# C Language and base tools and libraries
#
%files -f gcc.lang
%defattr(-,root,root)
%{_bindir}/cc
%{_bindir}/gcc
%{_bindir}/gcc-ar
%{_bindir}/gcc-nm
%{_bindir}/gcc-ranlib
%{_bindir}/gcov
%{_bindir}/gcov-dump
%{_bindir}/gcov-tool
%{_bindir}/lto-dump
%{_bindir}/%{_target_platform}-cc
%{_bindir}/%{_target_platform}-gcc-%{version}
%{_bindir}/%{_target_platform}-gcc
%{_bindir}/%{_target_platform}-gcc-ar
%{_bindir}/%{_target_platform}-gcc-nm
%{_bindir}/%{_target_platform}-gcc-ranlib
%{_bindir}/%{_target_platform}-gcov
%dir %{_libdir}/gcc
%{_libdir}/gcc/*
%ifarch x86_64 aarch64
%exclude %{_libdir}/gcc/%{_target_platform}/%{version}/32/*
%endif
%dir %{_prefix}/libexec/gcc/%{_target_platform}/%{version}
%{_prefix}/libexec/gcc/%{_target_platform}/%{version}/*
%{_libdir}/bfd-plugins/liblto_plugin.so
%{_datadir}/gcc-%{version}/python/libstdcxx/__init__.py
%{_datadir}/gcc-%{version}/python/libstdcxx/v6/__init__.py
%{_datadir}/gcc-%{version}/python/libstdcxx/v6/printers.py
%{_mandir}/man1/gcc.1.*
%{_mandir}/man1/gcov.1.*
%{_mandir}/man1/gcov-dump.1.*
%{_mandir}/man1/gcov-tool.1.*
%{_mandir}/man1/lto-dump.1*
%{_mandir}/man7/fsf-funding.7.*
%{_mandir}/man7/gfdl.7.*
%{_mandir}/man7/gpl.7.*
%doc gcc/{README*,*ChangeLog*}
%exclude %{_libdir}/gcc/%{_target_platform}/%{version}/include/objc
%exclude %{_libdir}/gcc/%{_target_platform}/%{version}/include/ssp

%files -n libgcc
%defattr(-,root,root)
%{_libdir}/libgcc*
%ifarch ppc
%{_libdir}/nof/libgcc*
%endif

%files cpp -f cpplib.lang
%defattr(-,root,root)
%{_libdir}/cpp
%{_bindir}/cpp
%{_mandir}/man1/cpp.1*

%files -n libiberty-devel
%defattr(-,root,root)
%dir %{_includedir}/libiberty
%{_includedir}/libiberty/*.h
%{_libdir}/libiberty.a

%files -n libcc1
%defattr(-,root,root)
%{_libdir}/libcc1.so.*

%files -n libcc1-devel
%defattr(-,root,root)
%{_libdir}/libcc1.so

%files -n libitm
%defattr(-,root,root)
%{_libdir}/libitm.so.*

%files -n libitm-devel
%defattr(-,root,root)
%{_libdir}/libitm.a
%{_libdir}/libitm.so
%{_libdir}/libitm.spec
%{_infodir}/libitm.info.gz

%files -n libgomp
%defattr(-,root,root)
%{_libdir}/libgomp.so.*
%ifarch ppc
%{_libdir}/nof/libgomp.so.*
%endif

%files -n libgomp-devel
%defattr(-,root,root)
%{_libdir}/libgomp.a
%{_libdir}/libgomp.so
%{_libdir}/libgomp.spec
%ifarch ppc
%{_libdir}/nof/libgomp.a
%{_libdir}/nof/libgomp.so
%{_libdir}/nof/libgomp.spec
%endif
%{_datadir}/info/libgomp.info.gz

%files -n libobjc
%defattr(-,root,root)
%{_libdir}/libobjc.so.*
%ifarch ppc
%{_libdir}/nof/libobjc.so.*
%endif

%files -n libobjc-devel
%defattr(-,root,root)
%{_libdir}/libobjc.a
%{_libdir}/libobjc.so
%ifarch ppc
%{_libdir}/nof/libobjc.a
%{_libdir}/nof/libobjc.so
%endif
%dir %{_libdir}/gcc/%{_target_platform}/%{version}/include/objc
%{_libdir}/gcc/%{_target_platform}/%{version}/include/objc/*

%files -n libssp
%defattr(-,root,root)
%{_libdir}/libssp.so.*
%ifarch ppc
%{_libdir}/nof/libssp.so.*
%endif

%files -n libssp-devel
%defattr(-,root,root)
%{_libdir}/libssp.a
%{_libdir}/libssp.so
%{_libdir}/libssp_nonshared.a
%ifarch ppc
%{_libdir}/nof/libssp.a
%{_libdir}/nof/libssp.so
%{_libdir}/nof/libssp_nonshared.a
%endif
%dir %{_libdir}/gcc/%{_target_platform}/%{version}/include/ssp
%{_libdir}/gcc/%{_target_platform}/%{version}/include/ssp/*

%files -n libasan
%defattr(-,root,root)
%{_libdir}/libasan.so.*
%ifarch x86_64 aarch64
%{_libdir}/libtsan.so.*
%endif

%files -n libasan-devel
%defattr(-,root,root)
%{_libdir}/libasan.a
%{_libdir}/libasan.so
%{_libdir}/libasan_preinit.o
%ifarch x86_64 aarch64
%{_libdir}/libtsan.a
%{_libdir}/libtsan.so
%{_libdir}/libtsan_preinit.o
%endif

%ifarch aarch64 x86_64
%files -n libhwasan
%defattr(-,root,root)
%{_libdir}/libhwasan.so.*

%files -n libhwasan-devel
%defattr(-,root,root)
%{_libdir}/libhwasan.a
%{_libdir}/libhwasan.so
%{_libdir}/libhwasan_preinit.o

%files -n liblsan
%defattr(-,root,root)
%{_libdir}/liblsan.so.*

%files -n liblsan-devel
%defattr(-,root,root)
%{_libdir}/liblsan.a
%{_libdir}/liblsan.so
%{_libdir}/liblsan_preinit.o
%endif

%files -n libatomic
%defattr(-,root,root)
%{_libdir}/libatomic.so.*

%files -n libatomic-devel
%defattr(-,root,root)
%{_libdir}/libatomic.a
%{_libdir}/libatomic.so

%files -n libubsan
%defattr(-,root,root)
%{_libdir}/libubsan.so.*

%files -n libubsan-devel
%defattr(-,root,root)
%{_libdir}/libubsan.a
%{_libdir}/libubsan.so
%{_libdir}/libsanitizer.spec

%if "%{disable_cpp}" != "1"
#
# C++ language
#
# NOTE: libstdc++.lang moved here to prevent x86 biarch conflict of libstdc++6
%files c++ -f libstdc++.lang
%defattr(-,root,root)
%{_bindir}/c++
%{_bindir}/g++
%{_bindir}/%{_target_platform}-c++
%{_bindir}/%{_target_platform}-g++
%{_datadir}/gcc-%{version}/python/libstdcxx/v6/xmethods.py
%{_mandir}/man1/g++.1.*
#%doc gcc/cp/ChangeLog*

%files -n %{libstdcxx_name}
%defattr(-,root,root)
%{_libdir}/libstdc++.so.*
%ifarch ppc
%{_libdir}/nof/libstdc++.so.*
%endif

%files -n %{libstdcxx_name}-debug
%defattr(-,root,root)
%{_datadir}/gdb/auto-load/%{_libdir}/libstdc++.so.*

%files -n %{libstdcxx_name}-devel
%defattr(-,root,root)
%{_libdir}/libstdc++.a
%{_libdir}/libstdc++exp.a
%{_libdir}/libstdc++.so
%{_libdir}/libsupc++.a
%{_libdir}/libstdc++fs.a
%ifarch ppc
%{_libdir}/nof/libstdc++.a
%{_libdir}/nof/libstdc++.so
%{_libdir}/nof/libsupc++.a
%endif
%dir %{_includedir}/c++
%{_includedir}/c++/*
#%doc libstdc++-v3/{ChangeLog*,README*,doc/html/}
%endif

#
# D language
#
%files d
%defattr(-,root,root)
%{_bindir}/gdc
%{_bindir}/%{_target_platform}-gdc
%{_libdir}/libgdruntime.a
%{_libdir}/libgdruntime.so
%{_libdir}/libgphobos.a
%{_libdir}/libgphobos.so
%{_libdir}/libgphobos.spec
%{_infodir}/gdc.info*
%{_mandir}/man1/gdc.1*

%files -n libgdruntime
%defattr(-,root,root)
%{_libdir}/libgdruntime.so.*
%{_libdir}/libgphobos.so.*

%if "%{disable_fortran}" != "1"
#
# Fortran language
#
%files fortran
%defattr(-,root,root)
%{_bindir}/gfortran
%{_bindir}/%{_target_platform}-gfortran
%{_libdir}/libgfortran.a
%{_libdir}/libgfortran.so
%{_libdir}/libgfortran.spec
%ifarch ppc
%{_libdir}/nof/libgfortran.a
%{_libdir}/nof/libgfortran.so
%endif
%{_mandir}/man1/gfortran.1.*

%files -n libgfortran
%defattr(-,root,root)
%{_libdir}/libgfortran.so.*
%ifarch ppc
%{_libdir}/nof/libgfortran.so.*
%endif
%endif

%ifnarch arm aarch64
%files -n libquadmath
%defattr(-,root,root)
%{_libdir}/libquadmath.so.*

%files -n libquadmath-devel
%defattr(-,root,root)
%{_libdir}/libquadmath.a
%{_libdir}/libquadmath.so
%endif

%if "%{disable_go}" != "1"
#
# go language
#
%files go
%defattr(-,root,root)
%{_bindir}/gccgo
%{_bindir}/gcc-go
%{_bindir}/gofmt
%{_bindir}/%{_target_platform}-gccgo
%{_infodir}/gccgo.info*
%{_mandir}/man1/gccgo.1*
%{_mandir}/man1/go.1*
%{_mandir}/man1/gofmt.1*

%files -n libgo
%defattr(-,root,root)
%{_libdir}/libgo.so.*
%dir %{_libdir}/go/%{version}/%{_target_platform}
%{_libdir}/go/%{version}/%{_target_platform}/*

%files -n libgo-devel
%defattr(-,root,root)
%{_libdir}/libgo.a
%{_libdir}/libgo.so
%{_libdir}/libgobegin.a
%{_libdir}/libgolibbegin.a
%endif

%files doc
%defattr(-,root,root)
%{_infodir}/cpp.info.*
%{_infodir}/cppinternals.info.*
%{_infodir}/gcc.info.*
%{_infodir}/gccinstall.info.*
%{_infodir}/gccint.info.*
%if "%{disable_fortran}" != "1"
%{_infodir}/gfortran.info.*
%if "%{disable_doc}" != "1"
#%doc gcc/doc/gfortran.pdf
%endif
%endif
%{_infodir}/libquadmath.info.*
%if "%{disable_doc}" != "1"
%endif

#
# Multilib
#
%ifarch x86_64
%files -n gcc-multilib
%defattr(-,root,root)
%{_sysconfdir}/ld.so.conf.d/lib32-gcc.conf
%dir %{_libdir}/gcc/%{_target_platform}/%{version}/32
%{_libdir}/gcc/%{_target_platform}/%{version}/32/*
%{_prefix}/lib32/libgcc_s.so
%{_prefix}/lib32/libgcc_s.so.1
#
%{_prefix}/lib32/libstdc++.*a
%{_prefix}/lib32/libstdc++exp.a
%{_prefix}/lib32/libstdc++.so
%{_prefix}/lib32/libstdc++.so.*
%{_prefix}/lib32/libstdc++fs.*a
#
%{_prefix}/lib32/libasan.a
%{_prefix}/lib32/libasan.so
%{_prefix}/lib32/libasan.so.*
%{_prefix}/lib32/libasan_preinit.o
%{_prefix}/lib32/libatomic.a
%{_prefix}/lib32/libatomic.so
%{_prefix}/lib32/libatomic.so.*
#
# gfortran
#
%{_prefix}/lib32/libgfortran.a
%{_prefix}/lib32/libgfortran.so
%{_prefix}/lib32/libgfortran.so.*
%{_prefix}/lib32/libgfortran.spec
#
# go
#
%dir %{_prefix}/lib32/go
%dir %{_prefix}/lib32/go/%{version}
%dir %{_prefix}/lib32/go/%{version}/%{_target_platform}
%{_prefix}/lib32/go/%{version}/%{_target_platform}/*
%{_prefix}/lib32/libgo.a
%{_prefix}/lib32/libgo.so
%{_prefix}/lib32/libgo.so.*
%{_prefix}/lib32/libgobegin.a
%{_prefix}/lib32/libgolibbegin.a
#
#
#
%{_prefix}/lib32/libgomp.a
%{_prefix}/lib32/libgomp.so
%{_prefix}/lib32/libgomp.so.*
%{_prefix}/lib32/libgomp.spec
/usr/lib32/libitm.a
/usr/lib32/libitm.so
/usr/lib32/libitm.so.*
/usr/lib32/libitm.spec
/usr/lib32/libobjc.a
/usr/lib32/libobjc.so
/usr/lib32/libobjc.so.*
/usr/lib32/libssp.a
/usr/lib32/libssp.so
/usr/lib32/libssp.so.*
/usr/lib32/libssp_nonshared.a
/usr/lib32/libsupc++.a
/usr/lib32/libquadmath.a
/usr/lib32/libquadmath.so
/usr/lib32/libquadmath.so.*
/usr/lib32/libsanitizer.spec
/usr/lib32/libubsan.a
/usr/lib32/libubsan.so
/usr/lib32/libubsan.so.*
%{_prefix}/lib32/libgdruntime.a
%{_prefix}/lib32/libgdruntime.so
%{_prefix}/lib32/libgdruntime.so.*
%{_prefix}/lib32/libgphobos.a
%{_prefix}/lib32/libgphobos.so
%{_prefix}/lib32/libgphobos.so.*
%{_prefix}/lib32/libgphobos.spec
%{_datadir}/gdb/auto-load/usr/lib32/libstdc++.so.*-gdb.py
%endif

%else
#
# Cross-platform single package
#
%files -n cross-%{_target_platform}-%{name}%{?bootstrap_append}
%defattr(-,root,root)
%{_bindir}/%{_target_platform}-*
%if "%{_target_platform}" != "avr"
%if "%{?stage1}" != "1"
%{_prefix}/%{_target_platform}/include/*
%if "%{target_cpu}" == "x86_64"
%{_prefix}/%{_target_platform}/%{_lib}/*
%else
%{_prefix}/%{_target_platform}/lib/*
%endif
%endif
%if "%{target_cpu}" == "ppc"
%{_prefix}/%{_target_platform}/%{_lib}/nof/libgfortran.a
%{_prefix}/%{_target_platform}/%{_lib}/nof/libobjc.a
%endif
%endif
%{_libdir}/gcc/%{_target_platform}/%{version}/*
%if "%{target_cpu}" == "x86_64"
%{_libexecdir}/gcc/%{_target_platform}/%{version}/*
%else
%{_prefix}/libexec/gcc/%{_target_platform}/%{version}/*
%endif
%{_mandir}/man1/%{_target_platform}-*
%endif

%changelog
* Thu May 09 2024 Silvan Calarco <silvan.calarco@mambasoft.it> 14.1.0-1mamba
- update to 14.1.0

* Thu Aug 10 2023 Silvan Calarco <silvan.calarco@mambasoft.it> 13.2.0-1mamba
- update to 13.2.0

* Tue Jun 20 2023 Silvan Calarco <silvan.calarco@mambasoft.it> 13.1.1-2mamba
- libgomp: patch to workaround environ null pointer in initialize_env

* Sat Jun 17 2023 Silvan Calarco <silvan.calarco@mambasoft.it> 13.1.1-1mamba
- update to 13.1.1

* Sat Jun 10 2023 Silvan Calarco <silvan.calarco@mambasoft.it> 13.1.0-1mamba
- update to 13.1.0

* Thu Sep 29 2022 Silvan Calarco <silvan.calarco@mambasoft.it> 12.2.0-2mamba
- gcc-multilib: add /usr/lib32 to ldconfig paths

* Sun Aug 21 2022 Silvan Calarco <silvan.calarco@mambasoft.it> 12.2.0-1mamba
- update to 12.2.0

* Thu Apr 28 2022 Silvan Calarco <silvan.calarco@mambasoft.it> 11.3.0-1mamba
- update to 11.3.0

* Wed Jul 28 2021 Automatic Build System <autodist@mambasoft.it> 11.2.0-1mamba
- automatic version update by autodist

* Thu Apr 29 2021 Automatic Build System <autodist@mambasoft.it> 11.1.0-1mamba
- automatic version update by autodist

* Fri Jul 24 2020 Automatic Build System <autodist@mambasoft.it> 10.2.0-1mamba
- automatic version update by autodist

* Mon Jun 08 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 10.1.0-2mamba
- arm: added patch to provide futex atomic functions _M_futex_notify_all and _M_futex_wait_until (armv7)

* Mon May 11 2020 Automatic Build System <autodist@mambasoft.it> 10.1.0-1mamba
- automatic version update by autodist

* Fri Mar 13 2020 Automatic Build System <autodist@mambasoft.it> 9.3.0-1mamba
- automatic version update by autodist

* Sat Feb 29 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 9.2.0-4mamba
- install libiberty.a with pic support

* Thu Dec 05 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 9.2.0-3mamba
- added add and d languages; added --enable-cet=auto and more options

* Wed Aug 28 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 9.2.0-2mamba
- add legacy provides to libgcc_s.so.1

* Sun Aug 18 2019 Automatic Build System <autodist@mambasoft.it> 9.2.0-1mamba
- automatic version update by autodist

* Thu Aug 01 2019 Automatic Build System <autodist@mambasoft.it> 9.1.0-1mamba
- automatic version update by autodist

* Mon Mar 18 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 8.3.0-3mamba
- fix for liblto_plugin.so link added in previous release

* Sat Mar 16 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 8.3.0-2mamba
- added symlink %{_libdir}/bfd-plugins/liblto_plugin.so

* Fri Feb 22 2019 Automatic Build System <autodist@mambasoft.it> 8.3.0-1mamba
- automatic version update by autodist

* Thu Jul 26 2018 Automatic Build System <autodist@mambasoft.it> 8.2.0-1mamba
- automatic version update by autodist

* Fri May 18 2018 Automatic Build System <autodist@mambasoft.it> 8.1.0-1mamba
- automatic version update by autodist

* Thu Jan 25 2018 Automatic Build System <autodist@mambasoft.it> 7.3.0-1mamba
- automatic version update by autodist

* Thu Oct 19 2017 Silvan Calarco <silvan.calarco@mambasoft.it> 7.2.0-1mamba
- update to 7.2.0

* Sat Jun 17 2017 Silvan Calarco <silvan.calarco@mambasoft.it> 7.1.0-1mamba
- update to 7.1.0

* Wed Aug 24 2016 Automatic Build System <autodist@mambasoft.it> 6.2.0-1mamba
- automatic version update by autodist

* Mon May 09 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 6.1.0-2mamba
- patched for libgcj abi minor

* Wed May 04 2016 Automatic Build System <autodist@mambasoft.it> 6.1.0-1mamba
- automatic version update by autodist

* Fri Dec 11 2015 Automatic Build System <autodist@mambasoft.it> 5.3.0-1mamba
- automatic version update by autodist

* Sat Nov 21 2015 Silvan Calarco <silvan.calarco@mambasoft.it> 5.2.0-2mamba
- rebuilt with go
- move to %{_libdir} files formerly installed in /%{_lib}

* Sun Aug 16 2015 Automatic Build System <autodist@mambasoft.it> 5.2.0-1mamba
- automatic version update by autodist

* Thu Apr 09 2015 Silvan Calarco <silvan.calarco@mambasoft.it> 4.9.2-2mamba
- new target: arm-openmamba-linux-gnueabihf

* Thu Oct 30 2014 Automatic Build System <autodist@mambasoft.it> 4.9.2-1mamba
- automatic version update by autodist

* Sun Jul 27 2014 Automatic Build System <autodist@mambasoft.it> 4.9.1-1mamba
- automatic version update by autodist

* Mon Jun 16 2014 Silvan Calarco <silvan.calarco@mambasoft.it> 4.9.0-2mamba
- apply upstream fixes to fix crashes seen in libQtScript after building Qt (seehttps://bugzilla.redhat.com/show_bug.cgi?id=1091482 ) 

* Sat May 03 2014 Automatic Build System <autodist@mambasoft.it> 4.9.0-1mamba
- automatic version update by autodist

* Wed Oct 16 2013 Automatic Build System <autodist@mambasoft.it> 4.8.2-1mamba
- automatic version update by autodist

* Sat Jul 27 2013 Silvan Calarco <silvan.calarco@mambasoft.it> 4.8.1-2mamba
- add %{_target_platform}-cc link to cc
- make %{_target_platform}-* symlink instead of binary duplicates
- x86_64: fix moving out of libdir libstdc++.so.6.0.18-gdb.py for lib32 package

* Tue Jun 04 2013 Automatic Build System <autodist@mambasoft.it> 4.8.1-1mamba
- automatic version update by autodist

* Thu Mar 28 2013 Automatic Build System <autodist@mambasoft.it> 4.8.0-1mamba
- automatic version update by autodist

* Tue Sep 25 2012 Silvan Calarco <silvan.calarco@mambasoft.it> 4.7.2-2mamba
- rebuild with stack protector support in cross-compilers (removed --disable-libssp)

* Fri Sep 21 2012 Automatic Build System <autodist@mambasoft.it> 4.7.2-1mamba
- automatic update by autodist

* Thu Jun 14 2012 Automatic Build System <autodist@mambasoft.it> 4.7.1-1mamba
- automatic version update by autodist

* Mon Apr 02 2012 Automatic Build System <autodist@mambasoft.it> 4.7.0-1mamba
- automatic version update by autodist

* Wed Oct 26 2011 Automatic Build System <autodist@mambasoft.it> 4.6.2-1mamba
- automatic version update by autodist

* Wed Jun 29 2011 Automatic Build System <autodist@mambasoft.it> 4.6.1-1mamba
- automatic update by autodist

* Fri Apr 01 2011 Automatic Build System <autodist@mambasoft.it> 4.6.0-1mamba
- automatic update by autodist

* Fri Dec 17 2010 Automatic Build System <autodist@mambasoft.it> 4.5.2-1mamba
- automatic update to 4.5.2 by autodist

* Fri Sep 24 2010 Silvan Calarco <silvan.calarco@mambasoft.it> 4.5.1-2mamba
- added obj-c++ and lto languages support
- added patch to fix bootstrap build
- added disable_java, disable_gjdoc, disable_jack build options
- build c,objc,fortran in stage1 mode
- don't provide libffi and libffi-devel in favour of external package (here it is used to embed it in gcj)

* Sat Jul 31 2010 Automatic Build System <autodist@mambasoft.it> 4.5.1-1mamba
- automatic update to 4.5.1 by autodist

* Tue Jul 20 2010 Silvan Calarco <silvan.calarco@mambasoft.it> 4.5.0-4mamba
- added libffi patch to support pkgconfig libffi.pc (as needed by pygobject)

* Sun Jul 18 2010 Automatic Build System <autodist@mambasoft.it> 4.5.0-3mamba
- automatic rebuild by autodist

* Sat May 29 2010 Silvan Calarco <silvan.calarco@mambasoft.it> 4.5.0-2mamba
- moved libstdc++.so.6.0.14-gdb.py for /usr/lib to gdb python dir to prevent ldconfig warning

* Sun May 09 2010 Automatic Build System <autodist@mambasoft.it> 4.5.0-1mamba
- automatic update to 4.5.0 by autodist

* Sat Apr 17 2010 Silvan Calarco <silvan.calarco@mambasoft.it> 4.4.3-2mamba
- modified to use standard rpm platform variables

* Thu Jan 21 2010 Automatic Build System <autodist@mambasoft.it> 4.4.3-1mamba
- automatic update to 4.4.3 by autodist

* Thu Oct 15 2009 Automatic Build System <autodist@mambasoft.it> 4.4.2-1mamba
- automatic update to 4.4.2 by autodist

* Sat Jul 25 2009 Automatic Build System <autodist@mambasoft.it> 4.4.1-1mamba
- automatic update to 4.4.1 by autodist

* Tue Jun 30 2009 Automatic Build System <autodist@mambasoft.it> 4.4.0-4mamba
- added pr39543 patch (fixes mplayer build)

* Sat May 23 2009 Automatic Build System <autodist@mambasoft.it> 4.4.0-3mamba
- automatic rebuild by autodist

* Fri Apr 24 2009 Automatic Build System <autodist@mambasoft.it> 4.4.0-2mamba
- automatic rebuild by autodist

* Wed Apr 22 2009 Automatic Build System <autodist@mambasoft.it> 4.4.0-1mamba
- automatic update to 4.4.0 by autodist

* Thu Apr 16 2009 Silvan Calarco <silvan.calarco@mambasoft.it> 4.3.3-2mamba
- added patch to disable fixincludes script

* Sat Jan 31 2009 Silvan Calarco <silvan.calarco@mambasoft.it> 4.3.3-1mamba
- automatic update by autodist

* Fri Sep 12 2008 Silvan Calarco <silvan.calarco@mambasoft.it> 4.3.2-2mamba
- added ecj.jar and /usr/bin/ecj1 bytecode interpreter wrapper from eclipse
- gcc-fortran: added requirement for exact release of gcc

* Sat Aug 30 2008 Silvan Calarco <silvan.calarco@mambasoft.it> 4.3.2-1mamba
- update to 4.3.2

* Thu Jul 10 2008 Silvan Calarco <silvan.calarco@mambasoft.it> 4.2.4-3mamba
- set correct path for current java-gcj-compat environment
- libgcj4-devel: don't obsolete libgcj3-devel and provide libgcj-devel
- libgcj4: provide libgcj

* Mon Jul 07 2008 Silvan Calarco <silvan.calarco@mambasoft.it> 4.2.4-2mamba
- added shared-openmp patch to allow dlopen of libgomp
- gcc-cpp: added requirement for gcc

* Wed Jun 04 2008 Silvan Calarco <silvan.calarco@mambasoft.it> 4.2.4-1mamba
- update to 4.2.4

* Mon Dec 10 2007 Silvan Calarco <silvan.calarco@mambasoft.it> 4.2.2-1mamba
- update to 4.2.2

* Mon Jul 23 2007 Silvan Calarco <silvan.calarco@mambasoft.it> 4.2.1-1mamba
- update to 4.2.1
- libstdcxx: provide libstdc++

* Wed May 16 2007 Silvan Calarco <silvan.calarco@mambasoft.it> 4.2.0-1mamba
- update to 4.2.0
- use make pdf to build pdf documentation

* Thu Mar 08 2007 Silvan Calarco <silvan.calarco@mambasoft.it> 4.1.2-1qilnx
- update to version 4.1.2 by autospec

* Tue Aug 22 2006 Silvan Calarco <silvan.calarco@mambasoft.it> 4.1.1-2qilnx
- added arm-softfloat target support (multilib libgcc support)

* Tue Jun 06 2006 Silvan Calarco <silvan.calarco@mambasoft.it> 4.1.1-1qilnx
- update to version 4.1.1 by autospec
- added arm platform support
- added support for stage1 build with autodist

* Mon Nov 14 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.2-5qilnx
- added patch to bug #24109 (see http://gcc.gnu.org/bugzilla/show_bug.cgi?id=24109)

* Tue Oct 25 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.2-4qilnx
- add libjava patch to java.awt.Window backported from Classpath 0.18 for ooo2

* Mon Oct 24 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.2-3qilnx
- add a patch for java zextract, see http://gcc.gnu.org/bugzilla/show_bug.cgi?id=23617)

* Fri Oct 21 2005 Davide Madrisan <davide.madrisan@qilinux.it> 4.0.2-2qilnx
- install/uninstall info files
- Silvan Calarco: add nofixincludes patch

* Thu Sep 29 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.2-1qilnx
- new version build

* Fri Sep 23 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.1-5qilnx
- added libgfortran sub-package
- description of libffi corrected
- removed requirements for gcc in gcc-java and gcc-fortran

* Tue Aug 23 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.1-4qilnx
- rebuilt with fixincludes script disabled

* Mon Aug 22 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.1-3qilnx
- first ppc full cross-platform compiler build

* Wed Aug 17 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.1-2qilnx
- rebuilt with standard gcc sources
- removed Obsoletes field for some library

* Mon Aug 15 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 4.0.1-1qilnx
- first gcc4 build (using RedHat sources)

* Thu Jul 21 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 3.4.4-2qilnx
- build with host os = linux-gnu

* Tue Jul 19 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 3.4.4-1qilnx
- update to version 3.4.4 by autospec

* Tue Jul 19 2005 Silvan Calarco <silvan.calarco@mambasoft.it> 3.4.3-4qilnx
- rebuild with default rpm target platform (i586-qilinux-linux)

* Wed Apr 06 2005 Davide Madrisan <davide.madrisan@qilinux.it> 3.4.3-2qilnx
- do not fix non standard include files found at building time
- fixed package group
- added missing symlinks

* Mon Nov 15 2004 Davide Madrisan <davide.madrisan@qilinux.it> 3.4.3-1qilnx
- updated to gcc-3.4.3

* Wed Sep 15 2004 Davide Madrisan <davide.madrisan@qilinux.it> 3.4.2-2qilnx
- libstdc++6-devel obsoletes libstdc++5-devel

* Mon Sep 13 2004 Silvan Calarco <silvan.calarco@mambasoft.it> 3.4.2-1qilnx
- new version build
- added x-includes-dir and x-library-dir configure paths

* Mon Jun 21 2004 Silvan Calarco <silvan.calarco@mambasoft.it> 3.4.0-1qilnx
- new version build

* Wed Apr 07 2004 Davide Madrisan <davide.madrisan@qilinux.it> 3.3.3-1qilnx
- first build for 3.3.3
- added cpp and g77, libf2c packages
- added documentation in text and pdf formats

* Mon Jun 16 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.3-1qilnx
- first build for 3.2.3

* Fri May 16 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.2-7qilnx
- added libstdc++.so symlink in devel package

* Thu Apr 24 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.2-6qilnx
- added symlinks /usr/lib/cpp and /usr/bin/cc

* Thu Apr 24 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.2-5qilnx
- added symlink /lib/cpp

* Thu Apr 17 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.2-4qilnx
- fixed install problems by using make install DESTDIR=xxxx

* Wed Apr 16 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.2-3qilnx
- changed %%dir reference to system dirs with more specific file lists
- added -doc package

* Mon Apr 14 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.2-2qilnx
- changed all .bz2 occurences with *

* Wed Apr 09 2003 Silvan Calarco <silvan.calarco@qinet.it> 3.2.2-1qilnx
- first build for 3.2.2
